Contenedores de Apptainer
-------------------------

En este repositorio se encuentran archivos de definición de contenedores de
Apptainer desarrollados para correr en TUPAC.

Para generar una imagen en base a ellos se debe ejecutar:

```
apptainer build imagen.sif definicion.def
```

Esto generará una imagen SIF de sólo lectura la cual al ser invocada se
comportará como un entorno virtual.

Luego la misma puede ser ejecutada como

```
apptainer exec imagen.sif comando
```

para ejecutar un comando dentro del entorno o como

```
apptainer shell imagen.sif
```

para instanciar el contenedor. Notar que en el caso de instanciarlo dado que la
imagen es de sólo lectura no podrán hacerse cambios en el sistema de archivos.

Para contenedores con Open MPI v3.x o superior los mismos soportan PMIx v2.x
por lo que pueden ser invocados dentro de Slurm con

```
srun --mpi=pmix apptainer exec imagen.sif comando
```

utilizándose la versión de MPI que esté dentro del contenedor para la
ejecución.

La documentación principal de Apptaner en TUPAC se encuentra
[acá](https://redmine.tupac.gob.ar/projects/tupac/wiki/Contenedores_Apptainer).
